module Data.Metadata.Projector
  ( FromBook(..)
  , HasAuthors(..) 
  , HasDomains(..)
  , InFile(..)
  , TXMText
  , Unique(..) ) where

import Data.Metadata.Types (Authors(..), Book, Domains(..))
import Data.Text (Text)

class Unique a where
  uid :: a -> String

class FromBook a where
  book :: a -> Book

class HasAuthors a where
  authors_ :: a -> Authors

  authors :: a -> [Text]
  authors = getAuthors . authors_

class HasDomains a where
  domains_ :: a -> Domains

  domains :: a -> [Text]
  domains = getDomains . domains_

class InFile a where
  relativePath :: a -> FilePath

type TXMText a = (Unique a, FromBook a, HasAuthors a, HasDomains a)
