{-# LANGUAGE OverloadedStrings #-}
module Data.Metadata.Types
  ( Authors(..)
  , Book(..)
  , Domains(..) ) where

import Control.Applicative (empty)
import Data.Csv (Field, FromField(..), Parser, ToField(..))
import Data.Text (Text, intercalate, splitOn)

data Book = EDdA | LGE | Wikipedia deriving (Eq, Ord, Read, Show)

newtype Authors = Authors
  { getAuthors :: [Text] } deriving Show
newtype Domains = Domains
  { getDomains :: [Text] } deriving Show

instance FromField Book where
  parseField "EDdA" = pure EDdA
  parseField "LGE" = pure LGE
  parseField "Wikipedia" = pure Wikipedia
  parseField _ = empty
instance ToField Book where
  toField = toField . show

sepBy :: Text -> Field -> Parser [Text]
sepBy s = fmap (splitOn s) . parseField

instance FromField Authors where
  parseField = fmap Authors . sepBy " & "
instance ToField Authors where
  toField = toField . intercalate " & ". getAuthors

instance FromField Domains where
  parseField = fmap Domains . sepBy " | "
instance ToField Domains where
  toField = toField . intercalate " | ". getDomains

